import { createEnv } from "@t3-oss/env-nextjs"
import { z } from "zod"

export const env = createEnv({
    server: {
        DATABASE_URL: z.string().min(1),
        GITHUB_CLIENT_ID: z.string().min(1),
        GITHUB_CLIENT_SECRET: z.string().min(1),
        NEXTAUTH_URL: z.string().url().optional(),
        NEXTAUTH_SECRET: z.string().min(1),
        TWITCH_CLIENT_ID: z.string().min(1),
        TWITCH_CLIENT_SECRET: z.string().min(1),
        TWITCH_AUTH_BASE_URL: z.string().url().optional(),
        IGDB_BASE_URL: z.string().url().optional(),
        IGDB_IMG_BASE_URL: z.string().url().optional(),
    },
    client: {
        NEXT_PUBLIC_APP_URL: z.string().min(1),
    },
    runtimeEnv: {
        DATABASE_URL: process.env.DATABASE_URL,
        GITHUB_CLIENT_ID: process.env.GITHUB_CLIENT_ID,
        GITHUB_CLIENT_SECRET: process.env.GITHUB_CLIENT_SECRET,
        NEXTAUTH_URL: process.env.NEXTAUTH_URL,
        NEXTAUTH_SECRET: process.env.NEXTAUTH_SECRET,
        NEXT_PUBLIC_APP_URL: process.env.NEXT_PUBLIC_APP_URL,
        TWITCH_CLIENT_ID: process.env.TWITCH_CLIENT_ID,
        TWITCH_CLIENT_SECRET: process.env.TWITCH_CLIENT_SECRET,
        TWITCH_AUTH_BASE_URL: process.env.TWITCH_AUTH_BASE_URL,
        IGDB_BASE_URL: process.env.IGDB_BASE_URL,
        IGDB_IMG_BASE_URL: process.env.IGDB_IMG_BASE_URL,
    },
})